//tempinho.cpp
//Example: class template with inheritance and operator overloading

#include <iostream.h>

template <class T>
class line         //base class
 {
  public:
        line(T length)
         { line::length = length; }
  protected:
        T length;
 };

template <class T>
class rectangle : public line<T>                //inherits from base class
 {
  public:
        rectangle(T length, T height) : line<T>(length)
         { rectangle::height = height; }

        T area()
         { return length * height; }

        void show()
         { cout << "The area is: " << area() << endl; }

  private:
        T height;
 };

void main(void)
 {
  rectangle<float> obj1(23.45, 24.56);
  rectangle<long> obj2(199999, 888888);
  rectangle<int>         obj3(23, 24);

  obj1.show();
  obj2.show();
  obj3.show();
 }

/* The following are output of this program:
The area is: 575.932
The area is: 1683051976
The area is: 552
*/


